# This file was created automatically by SWIG.
import edgesetc
class EdgeSetPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def addEdge_(self, *_args, **_kwargs):
        val = apply(edgesetc.EdgeSet_addEdge_,(self,) + _args, _kwargs)
        return val
    def ndlist(self, *_args, **_kwargs):
        val = apply(edgesetc.EdgeSet_ndlist,(self,) + _args, _kwargs)
        return val
    def size(self, *_args, **_kwargs):
        val = apply(edgesetc.EdgeSet_size,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C EdgeSet instance at %s>" % (self.this,)
class EdgeSet(EdgeSetPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(edgesetc.new_EdgeSet,_args,_kwargs)
        self.thisown = 1




class EdgeSetIteratorPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def edge(self, *_args, **_kwargs):
        val = apply(edgesetc.EdgeSetIterator_edge,(self,) + _args, _kwargs)
        if val: val = BoundaryEdgePtr(val) 
        return val
    def increment(self, *_args, **_kwargs):
        val = apply(edgesetc.EdgeSetIterator_increment,(self,) + _args, _kwargs)
        return val
    def end(self, *_args, **_kwargs):
        val = apply(edgesetc.EdgeSetIterator_end,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C EdgeSetIterator instance at %s>" % (self.this,)
class EdgeSetIterator(EdgeSetIteratorPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(edgesetc.new_EdgeSetIterator,_args,_kwargs)
        self.thisown = 1




class EdgeNodeDistancePtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __setattr__(self,name,value):
        if name == "node" :
            edgesetc.EdgeNodeDistance_node_set(self,value.this)
            return
        if name == "index" :
            edgesetc.EdgeNodeDistance_index_set(self,value)
            return
        if name == "distance" :
            edgesetc.EdgeNodeDistance_distance_set(self,value)
            return
        if name == "fraction" :
            edgesetc.EdgeNodeDistance_fraction_set(self,value)
            return
        self.__dict__[name] = value
    def __getattr__(self,name):
        if name == "node" : 
            return FuncNodePtr(edgesetc.EdgeNodeDistance_node_get(self))
        if name == "index" : 
            return edgesetc.EdgeNodeDistance_index_get(self)
        if name == "distance" : 
            return edgesetc.EdgeNodeDistance_distance_get(self)
        if name == "fraction" : 
            return edgesetc.EdgeNodeDistance_fraction_get(self)
        raise AttributeError,name
    def __repr__(self):
        return "<C EdgeNodeDistance instance at %s>" % (self.this,)
class EdgeNodeDistance(EdgeNodeDistancePtr):
    def __init__(self,this):
        self.this = this






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: edgeset.spy,v $
# $Revision: 1.1 $
# $Author: langer $
# $Date: 2005/10/18 17:31:23 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov.

# from oof2.SWIG.engine import node
from oof2.SWIG.engine.node import FuncNodePtr
from oof2.engine.profile import Location

def _EdgeSet___repr__(self):
    outstr = "EdgeSet( "
    for n in self.nodes():
        outstr = outstr + " %s " % n
    outstr = outstr + ")\n"
    return outstr

EdgeSet.__repr__ = _EdgeSet___repr__


# Utility function for building the cached progress data -- makes the
# expensive call into the C++ code to traverse the boundary, measuring
# progress in terms of nodes, node indices, distance traversed, and
# fractional distance traversed.  Caches the results, because it will
# be needed by each boundary condition.
def _EdgeSet_build_caches_(self):
    raw = self.ndlist()
    elist = map(EdgeNodeDistancePtr, raw)
    self.node_cache = map(lambda x: x.node, elist)
    self.location_cache = []
    for e in elist:
        self.location_cache.append(
            Location(e.node.position(), index=e.index,
                     s=e.distance, alpha=e.fraction))
    
EdgeSet.build_caches_ = _EdgeSet_build_caches_

# This is the function you should call to get a Python list of
# objects measuring progress along the boundary.  It calls the
# swigged-and-typemapped C++ "ndlist" function to get a list of
# EdgeNodeDistance pointers, and extracts the node information from it.
def _EdgeSet_nodes(self):
    try:
        return self.node_cache
    except AttributeError:
        self.build_caches_()
        return self.node_cache

EdgeSet.nodes = _EdgeSet_nodes

# Function to retrieve the list of locations from the edgeset.
# Locations are basically nodes, enhanced with extra information about
# how far along in the boundary you are.
def _EdgeSet_locations(self):
    try:
        self.location_cache
        self.node_cache
    except AttributeError:
        self.build_caches_()

    return map( None, self.node_cache, self.location_cache)

EdgeSet.locations = _EdgeSet_locations


# Wrapper to make sure that addEdge calls make both caches stale.
# Note that the caches are built by, among others, the __repr__, which
# is a little unintuitive.
def _EdgeSet_addEdge(self, boundaryedge):
    try:
        del self.node_cache
    except AttributeError:
        pass
    try:
        del self.location_cache
    except AttributeError:
        pass
    self.addEdge_(boundaryedge)


EdgeSetPtr.addEdge = _EdgeSet_addEdge

# Patterned after the FuncNodeIteratorPtr getitem routine in mesh.spy.
def _EdgeSetIterator___getitem__(self, idx):
    if self.end():
        raise IndexError
    ret = self.edge()
    self.increment()
    return ret

EdgeSetIteratorPtr.__getitem__ = _EdgeSetIterator___getitem__
