# This file was created automatically by SWIG.
import preconditionerc
class PreconditionerPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C Preconditioner instance at %s>" % (self.this,)
class Preconditioner(PreconditionerPtr):
    def __init__(self,this):
        self.this = this




class UnitPreconditionerPtr(PreconditionerPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __repr__(self):
        return "<C UnitPreconditioner instance at %s>" % (self.this,)
class UnitPreconditioner(UnitPreconditionerPtr):
    def __init__(self,this):
        self.this = this




class ILUPreconditionerPtr(UnitPreconditionerPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,preconditionerc=preconditionerc):
        if self.thisown == 1 :
            preconditionerc.delete_ILUPreconditioner(self)
    def __repr__(self):
        return "<C ILUPreconditioner instance at %s>" % (self.this,)
class ILUPreconditioner(ILUPreconditionerPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(preconditionerc.new_ILUPreconditioner,_args,_kwargs)
        self.thisown = 1




class ICPreconditionerPtr(UnitPreconditionerPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,preconditionerc=preconditionerc):
        if self.thisown == 1 :
            preconditionerc.delete_ICPreconditioner(self)
    def __repr__(self):
        return "<C ICPreconditioner instance at %s>" % (self.this,)
class ICPreconditioner(ICPreconditionerPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(preconditionerc.new_ICPreconditioner,_args,_kwargs)
        self.thisown = 1




class UnPreconditionerPtr(UnitPreconditionerPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,preconditionerc=preconditionerc):
        if self.thisown == 1 :
            preconditionerc.delete_UnPreconditioner(self)
    def __repr__(self):
        return "<C UnPreconditioner instance at %s>" % (self.this,)
class UnPreconditioner(UnPreconditionerPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(preconditionerc.new_UnPreconditioner,_args,_kwargs)
        self.thisown = 1




class JacobiPreconditionerPtr(UnitPreconditionerPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,preconditionerc=preconditionerc):
        if self.thisown == 1 :
            preconditionerc.delete_JacobiPreconditioner(self)
    def __repr__(self):
        return "<C JacobiPreconditioner instance at %s>" % (self.this,)
class JacobiPreconditioner(JacobiPreconditionerPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(preconditionerc.new_JacobiPreconditioner,_args,_kwargs)
        self.thisown = 1




class BlockPreconditionerPtr(PreconditionerPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,preconditionerc=preconditionerc):
        if self.thisown == 1 :
            preconditionerc.delete_BlockPreconditioner(self)
    def __repr__(self):
        return "<C BlockPreconditioner instance at %s>" % (self.this,)
class BlockPreconditioner(BlockPreconditionerPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(preconditionerc.new_BlockPreconditioner,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: preconditioner.spy,v $
# $Revision: 1.2 $
# $Author: reida $
# $Date: 2006/01/24 15:35:25 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from oof2.common import cregisteredclass
from oof2.common.IO import parameter
from oof2.common.IO import xmlmenudump
from types import *

cregisteredclass.registerCClass(PreconditionerPtr)

PreconditionerPtr.tip = \
                "Preconditioners for efficient solution of matrix equations."
PreconditionerPtr.discussion = xmlmenudump.loadFile(
    'DISCUSSIONS/engine/reg/preconditioner.xml')

cregisteredclass.registerCClass(UnitPreconditionerPtr)

UnitPreconditionerPtr.tip = \
          "Monolithic preconditioners for efficiently solving matrix equations."
UnitPreconditionerPtr.discussion = xmlmenudump.loadFile(
    'DISCUSSIONS/engine/reg/unitpreconditioner.xml')

# Special registration that registers the indicated class as both a
# Preconditioner and a UnitPreconditioner.
class UnitPreconditionerRegistration(cregisteredclass.Registration):
    def __init__(self, name, subclass, ordering,
                 params=[], secret=0, **kwargs):
        cregisteredclass.Registration.__init__(
            self, name, (PreconditionerPtr, UnitPreconditionerPtr),
            subclass, ordering, params, secret, **kwargs)

iluPreconditioner = UnitPreconditionerRegistration(
    "ILU",
    ILUPreconditioner,
    ordering=100,
    params=[],
    tip="Incomplete LU-factorization",
    discussion=xmlmenudump.loadFile('DISCUSSIONS/engine/reg/ilu_preconditioner.xml')
    )

UnitPreconditionerRegistration(
    "IC",
    ICPreconditioner,
    ordering=200,
    params=[],
    tip="Incomplete Cholesky preconditioner. Appropriate only for meshes with symmetric, positive definite stiffness matrices.",
    discussion=xmlmenudump.loadFile('DISCUSSIONS/engine/reg/ic_preconditioner.xml'))

UnitPreconditionerRegistration(
    "Null",
    UnPreconditioner,
    ordering=2000,
    params=[],
    tip="Be bold (or foolhardy) and attempt to solve the mesh without a preconditioner",
    discussion=xmlmenudump.loadFile('DISCUSSIONS/engine/reg/null_preconditioner.xml'))

UnitPreconditionerRegistration(
    "Jacobi",
    JacobiPreconditioner,
    ordering=500,
    params=[],
    tip="A light-weight preconditioner, that simply inverts the diagonal part of the matrix.",
    discussion=xmlmenudump.loadFile('DISCUSSIONS/engine/reg/jacobi_preconditioner.xml'))


# Block preconditioner is composite, so it uses the ordinary
# registration process.
blockPreconditioner = cregisteredclass.Registration(
    "Block",
    PreconditionerPtr,
    BlockPreconditioner,
    ordering=1000,
    params=[parameter.RegisteredParameter("inplane", UnitPreconditionerPtr,
                                          tip=parameter.emptyTipString)],
    tip="A preconditioner that treats in-plane and out-of-plane components differently.",
    discussion=xmlmenudump.loadFile('DISCUSSIONS/engine/reg/block_preconditioner.xml'))
