// -*- C++ -*-
// $RCSfile: angle2color.C,v $
// $Revision: 1.1 $
// $Author: langer $
// $Date: 2007/05/14 17:58:54 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>

// Methods for converting COrientations to colors, for display
// purposes.  Although the space of colors and the space of
// orientations are both three dimensional, they have different
// topologies, so there's no obviously best way of converting from one
// to the other.

#include "common/ccolor.h"
#include "engine/angle2color.h"
#include "engine/corientation.h"
#include <math.h>

CColor Bunge2RGB::operator()(const COrientation &angle) const {
  COrientBunge bunge = angle.bunge();
  double bunge1 = bunge.phi1()/(2.*M_PI) + 0.5;
  double bunge2 = bunge.theta()/M_PI;
  double bunge3 = bunge.phi2()/(2.*M_PI) + 0.5;
  return CColor(bunge1, bunge2, bunge3);
}

CColor Euler2RGB::operator()(const COrientation &angle) const {
  COrientABG abg = angle.abg();
  return CColor(abg.alpha()/M_PI,
		abg.beta()/(2.*M_PI) + 0.5,
		abg.gamma()/(2.*M_PI) + 0.5);
}
