// -*- C++ -*-
// $RCSfile: color.C,v $
// $Revision: 1.17 $
// $Author: langer $
// $Date: 2005/09/20 20:17:33 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>

#include "color.h"
#include "engine/material.h"

ColorProp::ColorProp(PyObject *reg, const std::string &nm, double g)
  : Property(nm,reg),
    cvalue_(g,g,g) // Color is gray, but object is CColor.
{
}

ColorProp::ColorProp(PyObject *reg, const std::string &nm, 
		     double r, double g, double b)
  : Property(nm,reg),
    cvalue_(r,g,b)
{
}

ColorProp::ColorProp(PyObject *reg, const std::string &nm, CColor &cv)
  : Property(nm,reg),
    cvalue_(cv)
{
}

ColorProp::ColorProp(PyObject *reg, const std::string &nm, CColor *cv)
  : Property(nm, reg),
    cvalue_(*cv)
{
}

