// -*- C++ -*-
// $RCSfile: nonlinear.h,v $
// $Revision: 1.5 $
// $Author: langer $
// $Date: 2006/12/19 20:29:47 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#ifndef NONLINEARELASTICITY_H
#define NONLINEARELASTICITY_H

#include "engine/property/elasticity/elasticity.h"
#include "engine/property/elasticity/cijkl.h"
#include <string>

class NonLinearElasticityProp : public Elasticity {
private:
  Cijkl cijkl_;
  double hardening;   // hardening coefficient
public:
  NonLinearElasticityProp(PyObject *registry, const std::string &name, 
		       Cijkl *c, double hardening);
  virtual ~NonLinearElasticityProp() {}
  Cijkl *cijkl_pointer() { return &cijkl_; }
  const Cijkl cijkl(const FEMesh*, const Element*, const MasterPosition&) const;
  double kappa() const { return hardening; }
  // virtual void cross_reference(Material*);
 

};

#endif
