// -*- C++ -*-
// $RCSfile: orientation.C,v $
// $Revision: 1.21 $
// $Author: langer $
// $Date: 2007/05/09 17:37:55 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>

#include "engine/property/orientation/orientation.h"
#include "engine/material.h"
#include "engine/matvec.h"
#include "engine/mvmult.h"
#include "engine/symmmatrix.h"
#include "common/trace.h"

OrientationProp::OrientationProp(PyObject *registry, const std::string &nm,
				 const COrientation *orient)
  : OrientationPropBase(registry,nm),
    orient(orient)
{}

OrientationProp::~OrientationProp() {}

const COrientation *OrientationProp::orientation(const FEMesh*, const Element*,
						 const MasterPosition&) const
{
  return orient;
}

// From the comments in eulerangle.C:
// ... The rotation matrix multiplied by a vector gives the
// coordinates of the vector in a coordinate system that has been
// rotated by the Euler angle.


// MATRIX_D OrientationProp::rotate(const MATRIX_D &A) const {
//   Trace("OrientationProp::rotate");
//   MATRIX_D rot = eulerangle().rotation();
//   return transform(A, rot); // rot.A.(rot-transpose), from mvmult.h
// }

// SymmMatrix3 OrientationProp::rotate(const SymmMatrix3 &A) const {
//   MATRIX_D a(3,3);
//   for(int i=0; i<3; i++)
//     for(int j=0; j<3; j++)
//       a(i,j) = A(i,j);
//   MATRIX_D rotated_a = rotate(a);
//   SymmMatrix3 result;
//   for(int i=0; i<3; i++)
//     for(int j=i; j<3; j++)
//       result(i,j) = rotated_a(i,j);
//   return result;
// }

// VECTOR_D OrientationProp::rotate(const VECTOR_D &x) const {
//   return eulerangle().rotation()*x;
// }
