# -*- python -*-
# $RCSfile: microstructurePage.py,v $
# $Revision: 1.1 $
# $Author: langer $
# $Date: 2007/05/17 19:10:14 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from oof2.SWIG.common import switchboard
from oof2.SWIG.orientationmap import orientmapdata
from oof2.common import guitop
from oof2.common.IO import microstructuremenu
from oof2.common.IO.GUI import fileselector
from oof2.common.IO.GUI import gtklogger
from oof2.common.IO.GUI import gtkutils
from oof2.common.IO.GUI import microstructurePage
import gtk
import os

# Create a MicrostructurePageInfoPlugIn that displays the Orientation
# map file name in the page's info box.

def _orientationmapinfo(microstructure):
    filename = orientmapdata.getOrientationMapFile(microstructure.getObject())
    if filename:
        direct, basename = os.path.split(filename)
        return 'Orientation Map file: ' + basename + '\ndirectory: ' + direct
    return 'Orientation Map file: <None>'

plugin = microstructurePage.addMicrostructureInfo(callback=_orientationmapinfo,
                                                  ordering=1)

switchboard.requestCallback('OrientationMap changed', plugin.update)

####################

# Add a button to the Microstructure page for the "New from
# Orientation Map" command.

def _newMSfromOrientationMap(button):
    menuitem = microstructuremenu.micromenu.Create_From_OrientationMap_File
    filename = fileselector.fileSelector(
        title='Create Microstructure from Orientation Map file',
        mode='r',
        params=filter(lambda x: x.name!='filename', menuitem.params))
    if file is not None:
        menuitem.callWithDefaults(filename=filename)
    
newfromorientmapbutton = gtkutils.stockButton(gtk.STOCK_NEW,
                                        "New from Orientation Map")
gtklogger.setWidgetName(newfromorientmapbutton, "NewFromOrientationMap")
gtklogger.connect(newfromorientmapbutton, 'clicked', _newMSfromOrientationMap)
guitop.top().tooltip(newfromorientmapbutton,
          "Create a new Microstructure from an Orientation Map data file.")

microstructurePage.addNewButton(newfromorientmapbutton)

