# -*- python -*-
# $RCSfile: orientmapIO.py,v $
# $Revision: 1.1 $
# $Author: langer $
# $Date: 2007/05/17 19:10:14 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

# Read and write orientation map data in Microstructure data files.

from oof2.common.IO import microstructureIO
from oof2.common.IO import oofmenu
from oof2.orientationmap import orientmapdata
import oof2.common.microstructure

def _loadOrientationMap(menuitem, microstructure, orientations):
    # orientations is a list of 3-tuples representing ABG Euler
    # angles.
    mscontext = oof2.common.microstructure.microStructures[microstructure]
    ms = mscontext.getObject()
    od = orientmapdata.OrientMap(ms.sizeInPixels(), ms.size())


def writeOrientationMap(datafile, mscontext):
    data = orientmapdata.getOrientationMap(mscontext.getObject())
    filename = orientmapdata.getOrientationMapFile(mscontext.getObject())
    
microstructureIO.registerMicrostructureIOPlugIn(writeOrientationMap)
