# -*- python -*-
# $RCSfile: orientmapdisplay.py,v $
# $Revision: 1.1 $
# $Author: langer $
# $Date: 2007/05/17 19:10:14 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from oof2.SWIG.common import coord
from oof2.SWIG.engine import angle2color
from oof2.SWIG.engine import orientationimage
from oof2.SWIG.orientationmap import orientmapdata
from oof2.common import color
from oof2.common import debug
from oof2.common import primitives
from oof2.common import registeredclass
from oof2.common.IO import display
from oof2.common.IO import parameter
from oof2.engine.IO import microstructuredisplay

# Redefine OrientationDisplay.draw so that it can use OrientationMap data.
# OrientationDisplay is defined in engine/microstructuredisplay.py.

## TODO: This is a poor way of extending the capabilities of
## OrientationDisplay.  It should have some sort of plug-in structure,
## so that future further extensions can be done independently of this
## one.

def _OD_draw(self, gfxwindow, device):
    msobj = self.who().getObject(gfxwindow)
    # See if the Microstructure has an orientation map.
    data = orientmapdata.getOrientationMap(msobj)
    if data is not None:
        orientimage = orientmapdata.OrientMapImage(data, self.colorscheme)
    else:
        orientimage = orientationimage.OrientationImage(msobj,
                                                     self.colorscheme,
                                                     self.no_material,
                                                     self.no_orientation)
    # Don't use OrientationImage.size() here, because orientimage may be
    # destroyed before drawing is complete.  msobj.size() refers to an
    # object that will be persistent.
    device.draw_image(orientimage, coord.Coord(0,0), msobj.size())
microstructuredisplay.OrientationDisplay.draw = _OD_draw

_old_timestamp = microstructuredisplay.MSMaterialDisplay.getTimeStamp
def _OD_timestamp(self, gfxwindow):
    microstructure = self.who().getObject(gfxwindow)
    data = orientmapdata.getOrientationMap(microstructure)
    if data:
        return max(_old_timestamp(self, gfxwindow),
                   orientmapdata.getOrientationMapTimestamp(microstructure))
    else:
        return _old_timestamp(self, gfxwindow)

microstructuredisplay.OrientationDisplay.getTimeStamp = _OD_timestamp
